library(ggplot2)
library(RColorBrewer)

load("Downloads/ErrorCyclePloteos_D4_intvar.Rdata")

k=8
patron <- list()
patron[[1]] <- matrix(values[[1]],365,k)


patron <- list()
par(mfrow=c(2,4))
for(cp in 1:8){
  k=cp
  patron[[1]] <- matrix(values[[1]],365,8)
  plot(patron[[1]][,k],type="l",col=brewer.pal("Set1",n=8)[k],ylim=c(0,100),main=paste("CP",k,gcms[[1]]))
  for(i in 2:40){
    patron[[i]] <- matrix(values[[i]],365,8)
    lines(patron[[i]][,k],col=brewer.pal("Set1",n=8)[k])
  }
  mean <- Reduce("+", patron) / length(patron)
  lines(valueERA5[,k],col="grey")
  lines(mean[,k],col="black")
}
meanACCESS <- mean

patron <- list()
par(mfrow=c(2,4))
for(cp in 1:8){
  k=cp
  patron[[43]] <- matrix(values[[43]],365,8)
  plot(patron[[43]][,k],type="l",col=brewer.pal("Set1",n=8)[k],ylim=c(0,100),main=paste("CP",k,gcms[[43]]))
  for(i in 44:60){
    patron[[i]] <- matrix(values[[i]],365,8)
    lines(patron[[i]][,k],col=brewer.pal("Set1",n=8)[k])
  }
  mean <- Reduce("+", patron[43:60]) / length(patron[43:60])
  lines(valueERA5[,k],col="grey")
  lines(mean[,k],col="black")
}
meanEC <- mean

patron <- list()
par(mfrow=c(2,4))
for(cp in 1:8){
  k=cp
  patron[[61]] <- matrix(values[[61]],365,8)
  plot(patron[[61]][,k],type="l",col=brewer.pal("Set1",n=8)[k],ylim=c(0,100),main=paste("CP",k,gcms[[61]]))
  for(i in 62:110){
    patron[[i]] <- matrix(values[[i]],365,8)
    lines(patron[[i]][,k],col=brewer.pal("Set1",n=8)[k])
  }
  mean <- Reduce("+", patron[61:110]) / length(patron[61:110])
  lines(valueERA5[,k],col="grey")
  lines(mean[,k],col="black")}
meanMIROC <- mean

patron <- list()
par(mfrow=c(2,4))
for(cp in 1:8){
  k=cp
  patron[[111]] <- matrix(values[[111]],365,8)
  plot(patron[[111]][,k],type="l",col=brewer.pal("Set1",n=8)[k],ylim=c(0,100),main=paste("CP",k,gcms[[111]]))
  for(i in 112:160){
    patron[[i]] <- matrix(values[[i]],365,8)
    lines(patron[[i]][,k],col=brewer.pal("Set1",n=8)[k])
  }
  mean <- Reduce("+", patron[111:160]) / length(patron[111:160])
  lines(valueERA5[,k],col="grey")
  lines(mean[,k],col="black")}
meanMPI <- mean

patron <- list()
par(mfrow=c(2,4))
for(cp in 1:8){
  k=cp
  patron[[161]] <- matrix(values[[161]],365,8)
  plot(patron[[161]][,k],type="l",col=brewer.pal("Set1",n=8)[k],ylim=c(0,100),main=paste("CP",k,gcms[[161]]))
  for(i in 162:170){
    patron[[i]] <- matrix(values[[i]],365,8)
    lines(patron[[i]][,k],col=brewer.pal("Set1",n=8)[k])
  }
  mean <- Reduce("+", patron[161:170]) / length(patron[161:170])
  lines(valueERA5[,k],col="grey")
  lines(mean[,k],col="black")}
meanMRI <- mean

############################################################################
#Correlations
k=8
corr <- matrix(NA,length(values),k)
for(run in 1:length(values)){
  for(cp in 1:k){
    patron <- matrix(values[[run]],365,k)
    corr[run,cp] <- cor(patron[,k],valueERA5[,k])    
  }
}

f <- function(x) {
  r <- quantile(x, probs = c(0.05, 0.25, 0.5, 0.75, 0.95))
  names(r) <- c("ymin", "lower", "middle", "upper", "ymax")
  r
}


data <- data.frame(Correlation=as.numeric(corr),
                   CP=rep(c(1:k),each=dim(corr)[1]),
                   GCM=rep(unlist(gcms),k),
                   Run=rep(unlist(runs),k))
data <- data[-which(data$GCM=="CanESM5"),]

cor.mean <- matrix(NA,5,8)
for(cp in 1:8){
cor.mean[1,cp] <- cor(valueERA5[,cp],meanACCESS[,cp])
cor.mean[2,cp] <- cor(valueERA5[,cp],meanEC[,cp])  
cor.mean[3,cp] <- cor(valueERA5[,cp],meanMIROC[,cp])  
cor.mean[4,cp] <- cor(valueERA5[,cp],meanMPI[,cp])  
cor.mean[5,cp] <- cor(valueERA5[,cp],meanMRI[,cp])  
}
data.mean <- data.frame(Correlation=as.numeric(cor.mean),
                        GCM=rep(c("ACCESS-ESM1-5","EC-Earth3","MIROC6","MPI-ESM1-2-LR","MRI-ESM2-0"),k),
                        CP=rep(c(1:k),each=5))

ggplot(data=data,aes(x=as.factor(CP),y=Correlation,fill=GCM)) + geom_violin(draw_quantiles = c(0.5))+
  #stat_summary(alpha=1,fun.data=f, geom="boxplot",position="dodge")+ 
  theme_bw() + geom_hline(yintercept = 0) + geom_dotplot(data=data.mean,binaxis = "y",stackdir = "center",position=position_dodge(1),shape=21,aes(x=as.factor(CP),y=Correlation,fill=GCM),dotsize = 0.5)+
  scale_fill_manual(values = brewer.pal(name="Paired",n=11)[c(1,3,5,7,9)],aesthetics = c("color","fill"))

#################################
#Caso MIROC6
for(cp in 1:8){
  k=cp
  patron[[61]] <- matrix(values[[61]],365,8)
  plot(patron[[61]][,k],type="l",col=brewer.pal("Set1",n=8)[k],ylim=c(0,100),main=paste("CP",k,gcms[[61]]))
  for(i in 62:110){
    patron[[i]] <- matrix(values[[i]],365,8)
    lines(patron[[i]][,k],col=brewer.pal("Set1",n=8)[k])
  }
  mean <- Reduce("+", patron[61:110]) / length(patron[61:110])
  lines(valueERA5[,k],col="grey")
  lines(mean[,k],col="black")}
meanMIROC <- mean


data.mean <- data.frame(GCM="MIROC6",Value=as.numeric(meanMIROC),Days=rep(1:365,8),CP=rep(1:8,each=365))
temp <- unlist(patron[62:118])
data <- data.frame(Value=temp,CP=rep(1:8,each=365),GCM="MIROC6",Days=rep(1:365,8))
data.ERA5 <- data.frame(GCM="ERA5",Value=as.numeric(valueERA5),Days=rep(1:365,8),CP=rep(1:8,each=365))

p <- ggplot(data=data,aes(x=Days,y=Value,col=CP)) + geom_line(data=data.ERA5,col="black") +geom_line(alpha=0.65) + theme_bw() + facet_wrap(~CP,nrow = 2)+
  scale_color_gradientn(colours=brewer.pal("Set1",n=8),breaks=c(1:8)) + geom_line(data=data.mean) + ylab("Frequency (%)") + 
  scale_x_continuous(breaks = seq(15,365,by=30),labels = c("J","F","M","A","M","J","J","A","S","O","N","D"))+
  guides(colour=guide_legend()) + ggtitle("MIROC6")
  
png(filename="../MIROC6_intvarCPs.png",res=600,width = 4500,height=2700)
print(p)
dev.off()
