rm(list=ls())
load("Downloads/tasmax_trends_intvar.Rdata")
load("Downloads/ERA5_trend (1).Rdata")
load("Downloads/dist.data.Rdata")

temp <- NA
for(i in seq_along(trend)){
  temp[i] <- mean(trend[[i]][[1]]$Data)
}

data.tasmax <- data.frame(Trend=temp,GCM=unlist(gcm.tx),Run=unlist(run.tx))
GCMRUN.tasmax <- paste(data.tasmax$GCM,data.tasmax$Run,sep="")

data.tasmax$Performance <- NA
data.tasmax$Run <- substr(data.tasmax$Run,start = 1,stop=nchar(data.tasmax$Run)-1)

for(i in seq_along(trend)){
  data.tasmax$Performance[i] <- dist.data$Distance[which(dist.data$GCM==data.tasmax$GCM[i] & dist.data$Run==data.tasmax$Run[i])]
}

ggplot(data=data.tasmax,aes(x=Performance,y=Trend,fill=GCM)) + geom_point(size=2,pch=21) + #facet_wrap(~GCM)+
  theme_bw() + scale_fill_manual(values = brewer.pal(n=8,name = "Set3")) +
  ggtitle("TASMAX JJA 1950-2014") + geom_hline(yintercept=ERA5$TX_Trend[which(ERA5$Season=="Summer")])

load("Downloads/precip_trends_intvar.Rdata")

temp <- NA
for(i in seq_along(trend)){
  temp[i] <- mean(trend[[i]][[1]]$Data)
}

data.pr <- data.frame(Trend=temp,GCM=unlist(gcm.pr),Run=unlist(run.pr))

data.pr$Performance <- NA
data.pr$Run <- substr(data.pr$Run,start = 1,stop=nchar(data.pr$Run)-1)

for(i in seq_along(trend)){
  data.pr$Performance[i] <- dist.data$Distance[which(dist.data$GCM==data.pr$GCM[i] & dist.data$Run==data.pr$Run[i])]
}

ggplot(data=data.pr,aes(x=Performance,y=Trend,fill=GCM)) + geom_point(size=2,pch=21) + #facet_wrap(~GCM)+
  theme_bw() + scale_fill_manual(values = brewer.pal(n=8,name = "Set3")) +
  ggtitle("PR JJA 1950-2014") + geom_hline(yintercept=ERA5$PR_Trend[which(ERA5$Season=="Summer")])


data.tasmax$Variable <- "TX"
data.pr$Variable <- "PR"

colnames(data.tasmax) <- c("TX_Trend","GCM","Run","Performance","Variable")
colnames(data.pr) <- c("PR_Trend","GCM","Run","Performance","Variable")


data.pr2 <- data.pr[which(paste(data.pr$GCM,data.pr$Run,sep="")%in%paste(data.tasmax$GCM,data.tasmax$Run,sep="")),]

data.combined <- cbind(data.tasmax,PR_Trend=data.pr2$PR_Trend)
ggplot(data=data.combined,aes(x=PR_Trend,y=TX_Trend,colour=GCM)) + geom_point(aes(size=Performance)) + theme_bw()+
  scale_fill_manual(values = brewer.pal(n=8,name = "Set3"),aesthetics = c("color","fill")) + ggtitle("JJA 1950-2014")
